-- GLOBALS: _, TBResserPosition
local tonumber, GetSubZoneText, GetAreaSpiritHealerTime, SendAddonMessage, GetRealZoneText, ceil, tostring, SetMapZoom =
      tonumber, GetSubZoneText, GetAreaSpiritHealerTime, SendAddonMessage, GetRealZoneText, ceil, tostring, SetMapZoom

local babble = LibStub("LibBabble-SubZone-3.0"):GetLookupTable()
local zonebabble = LibStub("LibBabble-Zone-3.0"):GetLookupTable()
local zoneIDs = {
	["Tol Barad"] = {
		Alliance={
			function(event,t)
				SetMapZoom(2,32)
				local tex,x,y = select(3,GetMapLandmarkInfo(1))
				if tex == 46 then
					-- alliance
					t[1][1] = babble["Baradin Hold"]
					t[1][2] = x
					t[1][3] = y
				else
					-- ICG
					t[1][1] = babble["Ironclad Garrison"]
					t[1][2] = 0.51188033819199
					t[1][3] = 0.26326876878738
					
					-- Slagworks
					t[2][1] = babble["Slagworks"]
					t[2][2] = 0.65763258934021
					t[2][3] = 0.65225923061371
					
					-- WV
					t[3][1] = babble["Warden's Vigil"]
					t[3][2] = 0.34626847505569
					t[3][3] = 0.69642668962479
				end
			end,
		},
		Horde={
			function(event,t)
				SetMapZoom(2,32)
				local tex,x,y = select(3,GetMapLandmarkInfo(1))
				if tex == 48 then
					-- horde
					t[1][1] = babble["Baradin Hold"]
					t[1][2] = x
					t[1][3] = y
				else
					-- ICG
					t[1][1] = babble["Ironclad Garrison"]
					t[1][2] = 0.51188033819199
					t[1][3] = 0.26326876878738
					
					-- Slagworks
					t[2][1] = babble["Slagworks"]
					t[2][2] = 0.65763258934021
					t[2][3] = 0.65225923061371
					
					-- WV
					t[3][1] = babble["Warden's Vigil"]
					t[3][2] = 0.34626847505569
					t[3][3] = 0.69642668962479
				end
			end,
		},
		chan = "RAID",
	},
	["Warsong Gulch"] = {
		Alliance={
			function(event,t)
				t[1][1] = babble["Silverwing Hold"]
				t[1][2] = 0.41731691360474
				t[1][3] = 0.28773474693298
			end,
		},
		Horde={
			function(event,t)
				t[1][1] = babble["Warsong Lumber Mill"]
				t[1][2] = 0.58104360103607
				t[1][3] = 0.73754417896271
			end,
		},
		chan = "BATTLEGROUND",
	},
	["Twin Peaks"] = {
		Alliance={
			function(event,t)
				t[1][1] = babble["Wildhammer Longhouse"]
				t[1][2] = 0.40519160032272
				t[1][3] = 0.48063737154007
			end,
		},
		Horde={
			function(event,t)
				t[1][1] = babble["Dragonmaw Clan Compound"]
				t[1][2] = 0.62299257516861
				t[1][3] = 0.54756534099579
			end,
		},
		chan = "BATTLEGROUND",
	},
	["Arathi Basin"] = {
		Alliance={
			function(event,t)
				-- force metatable to generate up to 5
				t[1][1] = nil
				t[2][1] = nil
				t[3][1] = nil
				t[4][1] = nil
				t[5][1] = nil
				
				t[6][1] = babble["Trollbane Hall"]
				t[6][2] = 0.32895231246948
				t[6][3] = 0.13300979137421
				
				for markNum=1, GetNumMapLandmarks() do
					local texState, x, y = select(3,GetMapLandmarkInfo(markNum))
					-- stables
					if texState == 38 then
						t[1][1] = babble["Stables"]
						t[1][2] = x
						t[1][3] = y
					end
					
					-- LM
					if texState == 23 then
						t[2][1] = babble["Lumber Mill"]
						t[2][2] = x
						t[2][3] = y
					end
					
					-- BS
					if texState == 28 then
						t[3][1] = babble["Blacksmith"]
						t[3][2] = x
						t[3][3] = y
					end
					
					-- GM
					if texState == 18 then
						t[4][1] = babble["Gold Mine"]
						t[4][2] = x
						t[4][3] = y
					end
					
					-- farm
					if texState == 33 then
						t[5][1] = babble["Farm"]
						t[5][2] = x
						t[5][3] = y
					end
				end
			end,
			"WORLD_MAP_UPDATE",
		},
		Horde={
			function(event,t)
				t[1][1] = nil
				t[2][1] = nil
				t[3][1] = nil
				t[4][1] = nil
				t[5][1] = nil
				
				t[6][1] = babble["Defiler's Den"]
				t[6][2] = 0.68806207180023
				t[6][3] = 0.67732381820679
				for markNum=1,GetNumMapLandmarks() do
					local texState, x, y = select(3,GetMapLandmarkInfo(markNum))
					-- stabs
					if texState == 40 then
						t[1][1] = babble["Stables"]
						t[1][2] = x
						t[1][3] = y
					end
					-- LM
					if texState == 25 then
						t[2][1] = babble["Lumber Mill"]
						t[2][2] = x
						t[2][3] = y
					end
					-- BS
					if texState == 30 then
						t[3][1] = babble["Blacksmith"]
						t[3][2] = x
						t[3][3] = y
					end
					-- GM
					if texState == 20 then
						t[4][1] = babble["Gold Mine"]
						t[4][2] = x
						t[4][3] = y
					end
					-- farm
					if texState == 35 then
						t[5][1] = babble["Farm"]
						t[5][2] = x
						t[5][3] = y
					end
				end
			end,
			"WORLD_MAP_UPDATE",
		},
		chan = "BATTLEGROUND",
	},
	["Alterac Valley"] = {
		chan = "BATTLEGROUND",
	},
	["Eye of the Storm"] = {
		Alliance={
			function(event,t)
				-- force generation of 4 tables
				t[1][1] = nil
				t[2][1] = nil
				t[3][1] = nil
				t[4][1] = nil
				
				t[5][1] = zonebabble["Eye of the Storm"]
				t[5][2] = 0.46804320812225
				t[5][3] = 0.26084488630295
				
				for markNum=1, GetNumMapLandmarks() do
					local name, _, texState, x, y = GetMapLandmarkInfo(markNum)
					if texState == 11 then
						if (name == babble["Mage Tower"]) then
							t[1][1] = name
							t[1][2] = x
							t[1][3] = y
						elseif (name == babble["Draenei Ruins"]) then
							t[2][1] = name
							t[2][2] = x
							t[2][3] = y
						elseif (name == babble["Fel Reaver Ruins"]) then
							t[3][1] = name
							t[3][2] = x
							t[3][3] = y
						elseif (name == babble["Blood Elf Tower"]) then
							t[4][1] = name
							t[4][2] = x
							t[4][3] = y
						end
					end
				end
			end,
			"WORLD_MAP_UPDATE",
		},
		Horde={
			function(event,t)
				t[1][1] = nil
				t[2][1] = nil
				t[3][1] = nil
				t[4][1] = nil
				
				for markNum=1, GetNumMapLandmarks() do
					local name, _, texState, x, y = GetMapLandmarkInfo(markNum)
					if texState == 10 then
						if (name == babble["Mage Tower"]) then
							t[1][1] = name
							t[1][2] = x
							t[1][3] = y
						elseif (name == babble["Draenei Ruins"]) then
							t[2][1] = name
							t[2][2] = x
							t[2][3] = y
						elseif (name == babble["Fel Reaver Ruins"]) then
							t[3][1] = name
							t[3][2] = x
							t[3][3] = y
						elseif (name == babble["Blood Elf Tower"]) then
							t[4][1] = name
							t[4][2] = x
							t[4][3] = y
						end
					end
				end
			end,
			"WORLD_MAP_UPDATE",
		},
		chan = "BATTLEGROUND",
	},
	--[[["Strand of the Ancients"] = {
	},--]]
	--[[["Battle for Gilneas"] = {
	},--]]
	--[[["Isle of Conquest"] = {
	},--]]
}
local rezTimer = 30
--babble = LibStub("LibBabble-SubZone-3.0"):GetReverseLookupTable()
local reversezonebabble = LibStub("LibBabble-Zone-3.0"):GetReverseLookupTable()
local graveyardList = setmetatable({},{__index=function(t,k) t[k] = {} return t[k] end})
local function nearestbase()
	local posX, posY = GetPlayerMapPosition("player")
	local lowestDistance, lowestBase = math.huge
	for subID, subData in ipairs(graveyardList) do
		if subData[1] then
			local baseDistance = math.sqrt(((posX-subData[2])^2)+((posY-subData[3])^2))
			if baseDistance < lowestDistance then
				lowestDistance = baseDistance
				lowestBase = subID
			end
		end
	end
	return lowestBase
end
local addon = CreateFrame("Frame", "TBResser", UIParent)
addon:Hide()
hooksecurefunc("StaticPopup_Show", function(key)
	if key == "AREA_SPIRIT_HEAL" then
		local zone = zoneIDs[reversezonebabble[GetRealZoneText()]]
		if zone then
			local baseID = nearestbase()
			if baseID then
				SendAddonMessage("TBResser", baseID.."|"..GetAreaSpiritHealerTime(), zone.chan)
			end
		end
	end
end)
addon.nearestUpdate = CreateFrame("Frame")
addon.nearestUpdate.nextUpdate = 1
addon.nearestUpdate:SetScript("OnUpdate",function(self,elapsed)
	self.nextUpdate = self.nextUpdate-elapsed
	if self.nextUpdate <= 0 then
		self.nextUpdate = 1
		addon.bar:SetNearestBase()
	end
end)
addon.graveyardEvents = CreateFrame("Frame")
addon.graveyardEvents:SetScript("OnEvent",function(self,e)
	addon:Hide()
	for _,t in ipairs(graveyardList) do if type(t) == "table" then table.wipe(t) end end
	table.wipe(graveyardList)
	self.data[1](e,graveyardList)
	addon.bar:SetNearestBase()
end)
addon:SetScript("OnEvent", function(self, event, pre, msg)
	if event == "CHAT_MSG_ADDON" and pre == "TBResser" then
		local base, t = msg:match("(%d+)|(%d+)")
		base = tonumber(base)
		t = tonumber(t)
		if base and t then
			addon.timers[base] = t
			addon.updates[base]:Show()
			addon.est[base] = false
			if addon.bar.base == base then
				addon.bar:Show()
				addon.bar:SetValue(t, false)
			end
		end
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		local engzone = reversezonebabble[GetRealZoneText()]
		local data = zoneIDs[engzone]
		addon:Hide()
		addon.nearestUpdate:Hide()
		addon.graveyardEvents:UnregisterAllEvents()
		addon.bar.base = nil
		for i=1, #addon.updates	do
			addon.updates[i]:Hide()
			addon.timers[i] = nil
			addon.est[i] = nil
		end
		if data then
			for _,t in ipairs(graveyardList) do if type(t) == "table" then table.wipe(t) end end
			table.wipe(graveyardList)
			local factionData = data[UnitFactionGroup("player")]
			factionData[1]("ZONE_CHANGED_NEW_AREA",graveyardList)
			for eventNum=2,#factionData do
				addon.graveyardEvents:RegisterEvent(factionData[eventNum])
			end
			addon.graveyardEvents.data = factionData
			addon.bar:SetNearestBase()
			addon.nearestUpdate:Show()
		end
		--addon.bar:SetBase(ids[babble[GetSubZoneText()]] or ids["default"],engzone)
	elseif event == "ADDON_LOADED" and pre == "TBResser" then
		TBResserPosition = TBResserPosition or {p="CENTER",r="CENTER",x=0,y=0}
		addon:SetPoint(TBResserPosition.p, nil, TBResserPosition.r, TBResserPosition.x, TBResserPosition.y)
		self:UnregisterEvent("ADDON_LOADED")
		self:GetScript("OnEvent")(self,"ZONE_CHANGED_NEW_AREA")
	end
	--[===[@debug@
	if event == "WORLD_MAP_UPDATE" then
		for i=1, GetNumMapLandmarks() do
			local name, desc, texIndex, posX, posY = GetMapLandmarkInfo(i)
			if name and desc and texIndex then
				TBResserPosition.landmarks = TBResserPosition.landmarks or {}
				TBResserPosition.landmarks[name] = TBResserPosition.landmarks[name] or {}
				if not TBResserPosition.landmarks[name][desc] then
					print(name.." - "..desc.." found: "..texIndex)
					TBResserPosition.landmarks[name][desc] = {texIndex,posX,posY}
				elseif TBResserPosition.landmarks[name][desc][1] ~= texIndex then
					print(name.." - "..desc.." updated: "..texIndex)
					TBResserPosition.landmarks[name][desc] = {texIndex,posX,posY}
				end
			end
		end
	end
	--@end-debug@]===]
end)
addon:SetSize(170, 35)
addon.tex = addon:CreateTexture()
addon.tex:SetAllPoints()
addon.tex:SetTexture(0.6,0.6,0.6)
addon.tex:SetAlpha(0.2)
addon.bar = CreateFrame("Frame", nil, addon)
addon.bar:SetSize(150, 15)
addon.bar:SetPoint("TOPLEFT", 10, -10)
addon.bar:SetPoint("BOTTOMRIGHT", -10, 10)
addon.bar.tex = addon.bar:CreateTexture(nil, "BACKGROUND")
addon.bar.tex:SetAllPoints()
addon.bar.tex:SetTexture(0.5,0.5,0.5)
addon.bar.tex:SetAlpha(0.8)
addon.bar.over = addon.bar:CreateTexture(nil, "ARTWORK")
addon.bar.over:SetPoint("TOPLEFT")
addon.bar.over:SetPoint("BOTTOMLEFT")
addon.bar.over:SetTexture(0.9,0.9,0.9)
addon.bar.over:SetAlpha(0.7)
addon.bar.text = addon.bar:CreateFontString(nil, "OVERLAY")
addon.bar.text:SetPoint("RIGHT", -5, 0)
addon.bar.text:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
addon.bar.text:SetTextColor(1,1,1)
addon.bar.label = addon.bar:CreateFontString(nil, "OVERLAY")
addon.bar.label:SetPoint("CENTER")
addon.bar.label:SetWidth(100)
addon.bar.label:SetWordWrap(false)
addon.bar.label:SetFont("Fonts\\FRIZQT__.TTF", 10, "OUTLINE")
addon.bar.label:SetTextColor(1,1,1)
addon.bar.estimate = addon.bar:CreateFontString(nil, "OVERLAY")
addon.bar.estimate:SetPoint("LEFT", 5, 0)
addon.bar.estimate:SetFont("Fonts\\FRIZQT__.TTF", 12)
addon.bar.estimate:SetTextColor(0,0,0)
addon.bar.estimate:SetText("E")
function addon.bar:SetValue(i, e)
	if i < rezTimer then
		self.over:SetWidth((1-(i/rezTimer))*150)
		self.over:Show()
	else
		self.over:Hide()
	end
	i = ceil(i)
	if i ~= self.textcache then
		self.textcache = i
		self.text:SetText(tostring(i))
	end
	if e ~= nil then
		self.estimate[e and "Show" or "Hide"](self.estimate)
	end
end
function addon.bar:SetBase(base)
	if base and addon.timers[base] then
		self:SetValue(addon.timers[base], addon.est[base])
		self.label:SetText(graveyardList[base][1])
		addon:Show()
		self.base = base
	else
		addon:Hide()
		self.base = nil
	end
end

function addon.bar:SetNearestBase()
	self:SetBase(nearestbase())
end
addon:RegisterEvent("CHAT_MSG_ADDON")
addon:RegisterEvent("ZONE_CHANGED_NEW_AREA")
addon:RegisterEvent("ADDON_LOADED")
--[===[@debug@
addon:RegisterEvent("WORLD_MAP_UPDATE")
--@end-debug@]===]
RegisterAddonMessagePrefix("TBResser")
addon.updates = {}
addon.timers = {}
addon.est = {}
setmetatable(addon.updates,{__index=function(t,i)
	local f = CreateFrame("Frame")
	f:Hide()
	f:SetScript("OnUpdate", function(self, elapsed)
		addon.timers[i]=addon.timers[i]-elapsed
		if addon.timers[i] < 0 then
			addon.timers[i] = addon.timers[i]+rezTimer
			addon.est[i] = true
			if addon.bar.base == i then
				addon.bar:SetValue(addon.timers[i], true)
			end
		else
			if addon.bar.base == i then
				addon.bar:SetValue(addon.timers[i])
			end
		end
	end)
	t[i] = f
	return f
end})
addon:SetMovable(true)
addon:EnableMouse(true)
addon:SetScript("OnMouseDown", function(self)
	self:StartMoving()
end)
addon:SetScript("OnMouseUp", function(self)
	self:StopMovingOrSizing()
	local t=TBResserPosition
	t.p, _, t.r, t.x, t.y = self:GetPoint()
end)